// SNF4CGP/OutputProcessor.cpp
// Copyright (C) 2009 ARM Research Labs, LLC.
// See www.armresearch.com for more information.

#include "OutputProcessor.hpp"

#include "../SNF4CGP/CodeDweller/faults.hpp"

using namespace std;

const ThreadType OutputProcessor::Type("Output Processor");
const ThreadState OutputProcessor::Uninitialized("Uninitialized");
const ThreadState OutputProcessor::StartingUp("Starting");
const ThreadState OutputProcessor::WaitingForJobs("Waiting");
const ThreadState OutputProcessor::PostingResponses("Posting");
const ThreadState OutputProcessor::ShuttingDown("Stopping");

OutputProcessor::OutputProcessor() :                                            // Constructor sets up the basics.
  Thread(OutputProcessor::Type, "Output"),                                      // Name the thread.
  RecycledJobs(0),                                                              // No job pool yet.
  isTimeToStop(false) {}                                                        // Not time to stop.

OutputProcessor::~OutputProcessor() {                                           // Destructor to clean things up.
}

RuntimeCheck CheckRecyclingNotNull("OutputProcessor::RecycledJobs() Check(0 != RecycledJobs_)");

JobPool& OutputProcessor::RecycledJobs() {                                      // Safe access to RecycledJobs
    CheckRecyclingNotNull(0 != RecycledJobs_);                                  // Throw if we have a null pointer.
    return *RecycledJobs_;                                                      // Good pointer? return a reference.
}

void OutputProcessor::init(JobPool& J) {                                        // Start processing.
}

void OutputProcessor::outputJob(Job* J) {                                       // Take this job and ... you know.
}

void OutputProcessor::stop() {                                                  // Finish off the queue and quit.
}

void OutputProcessor::myTask() {                                                // This is how we do it.
}
